using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;

namespace UserModule_BG_UHD_QVP_4X2
{
    public class UserModuleClass_BG_UHD_QVP_4X2 : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        Crestron.Logos.SplusObjects.DigitalInput REBOOT;
        Crestron.Logos.SplusObjects.DigitalInput FACTORY_RESET;
        Crestron.Logos.SplusObjects.DigitalInput FULL_SCREEN_A;
        Crestron.Logos.SplusObjects.DigitalInput FULL_SCREEN_B;
        Crestron.Logos.SplusObjects.DigitalInput FULL_SCREEN_C;
        Crestron.Logos.SplusObjects.DigitalInput FULL_SCREEN_D;
        Crestron.Logos.SplusObjects.DigitalInput QUAD_DEFAULT_SCREEN;
        Crestron.Logos.SplusObjects.AnalogInput SET_VIDEO_ROUTING_A;
        Crestron.Logos.SplusObjects.AnalogInput SET_VIDEO_ROUTING_B;
        Crestron.Logos.SplusObjects.AnalogInput SET_VIDEO_ROUTING_C;
        Crestron.Logos.SplusObjects.AnalogInput SET_VIDEO_ROUTING_D;
        Crestron.Logos.SplusObjects.AnalogInput SET_OUTPUT_RESOLUTION;
        Crestron.Logos.SplusObjects.AnalogInput RECALL_PRESET;
        Crestron.Logos.SplusObjects.StringOutput TX__DOLLAR__;
        object REBOOT_OnPush_0 ( Object __EventInfo__ )
        
            { 
            Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
            try
            {
                SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
                
                __context__.SourceCodeLine = 166;
                TX__DOLLAR__  .UpdateValue ( "#REBOOT\u000D\u000A"  ) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler( __SignalEventArg__ ); }
            return this;
            
        }
        
    object FACTORY_RESET_OnPush_1 ( Object __EventInfo__ )
    
        { 
        Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
        try
        {
            SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
            
            __context__.SourceCodeLine = 171;
            TX__DOLLAR__  .UpdateValue ( "#FACTORY_RESET\u000D\u000A"  ) ; 
            
            
        }
        catch(Exception e) { ObjectCatchHandler(e); }
        finally { ObjectFinallyHandler( __SignalEventArg__ ); }
        return this;
        
    }
    
object FULL_SCREEN_A_OnPush_2 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 176;
        TX__DOLLAR__  .UpdateValue ( "P A\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object FULL_SCREEN_B_OnPush_3 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 181;
        TX__DOLLAR__  .UpdateValue ( "P B\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object FULL_SCREEN_C_OnPush_4 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 186;
        TX__DOLLAR__  .UpdateValue ( "P C\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object FULL_SCREEN_D_OnPush_5 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 191;
        TX__DOLLAR__  .UpdateValue ( "P D\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object QUAD_DEFAULT_SCREEN_OnPush_6 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        
        __context__.SourceCodeLine = 196;
        TX__DOLLAR__  .UpdateValue ( "P Q\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_VIDEO_ROUTING_A_OnChange_7 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 212;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_VIDEO_ROUTING_A  .UshortValue) ; 
        __context__.SourceCodeLine = 213;
        TX__DOLLAR__  .UpdateValue ( "R A " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_VIDEO_ROUTING_B_OnChange_8 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 221;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_VIDEO_ROUTING_B  .UshortValue) ; 
        __context__.SourceCodeLine = 222;
        TX__DOLLAR__  .UpdateValue ( "R B " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_VIDEO_ROUTING_C_OnChange_9 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 230;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_VIDEO_ROUTING_C  .UshortValue) ; 
        __context__.SourceCodeLine = 231;
        TX__DOLLAR__  .UpdateValue ( "R C " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_VIDEO_ROUTING_D_OnChange_10 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 240;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_VIDEO_ROUTING_D  .UshortValue) ; 
        __context__.SourceCodeLine = 241;
        TX__DOLLAR__  .UpdateValue ( "R D " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object SET_OUTPUT_RESOLUTION_OnChange_11 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 1, this );
        
        
        __context__.SourceCodeLine = 249;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)SET_OUTPUT_RESOLUTION  .UshortValue) ; 
        __context__.SourceCodeLine = 250;
        TX__DOLLAR__  .UpdateValue ( "#SET_OUTPUT_RES " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}

object RECALL_PRESET_OnChange_12 ( Object __EventInfo__ )

    { 
    Crestron.Logos.SplusObjects.SignalEventArgs __SignalEventArg__ = (Crestron.Logos.SplusObjects.SignalEventArgs)__EventInfo__;
    try
    {
        SplusExecutionContext __context__ = SplusThreadStartCode(__SignalEventArg__);
        CrestronString STRINGINPUT1;
        STRINGINPUT1  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 2, this );
        
        
        __context__.SourceCodeLine = 257;
        MakeString ( STRINGINPUT1 , "{0:d}", (ushort)RECALL_PRESET  .UshortValue) ; 
        __context__.SourceCodeLine = 258;
        TX__DOLLAR__  .UpdateValue ( "P " + STRINGINPUT1 + "\u000D\u000A"  ) ; 
        
        
    }
    catch(Exception e) { ObjectCatchHandler(e); }
    finally { ObjectFinallyHandler( __SignalEventArg__ ); }
    return this;
    
}


public override void LogosSplusInitialize()
{
    SocketInfo __socketinfo__ = new SocketInfo( 1, this );
    InitialParametersClass.ResolveHostName = __socketinfo__.ResolveHostName;
    _SplusNVRAM = new SplusNVRAM( this );
    
    REBOOT = new Crestron.Logos.SplusObjects.DigitalInput( REBOOT__DigitalInput__, this );
    m_DigitalInputList.Add( REBOOT__DigitalInput__, REBOOT );
    
    FACTORY_RESET = new Crestron.Logos.SplusObjects.DigitalInput( FACTORY_RESET__DigitalInput__, this );
    m_DigitalInputList.Add( FACTORY_RESET__DigitalInput__, FACTORY_RESET );
    
    FULL_SCREEN_A = new Crestron.Logos.SplusObjects.DigitalInput( FULL_SCREEN_A__DigitalInput__, this );
    m_DigitalInputList.Add( FULL_SCREEN_A__DigitalInput__, FULL_SCREEN_A );
    
    FULL_SCREEN_B = new Crestron.Logos.SplusObjects.DigitalInput( FULL_SCREEN_B__DigitalInput__, this );
    m_DigitalInputList.Add( FULL_SCREEN_B__DigitalInput__, FULL_SCREEN_B );
    
    FULL_SCREEN_C = new Crestron.Logos.SplusObjects.DigitalInput( FULL_SCREEN_C__DigitalInput__, this );
    m_DigitalInputList.Add( FULL_SCREEN_C__DigitalInput__, FULL_SCREEN_C );
    
    FULL_SCREEN_D = new Crestron.Logos.SplusObjects.DigitalInput( FULL_SCREEN_D__DigitalInput__, this );
    m_DigitalInputList.Add( FULL_SCREEN_D__DigitalInput__, FULL_SCREEN_D );
    
    QUAD_DEFAULT_SCREEN = new Crestron.Logos.SplusObjects.DigitalInput( QUAD_DEFAULT_SCREEN__DigitalInput__, this );
    m_DigitalInputList.Add( QUAD_DEFAULT_SCREEN__DigitalInput__, QUAD_DEFAULT_SCREEN );
    
    SET_VIDEO_ROUTING_A = new Crestron.Logos.SplusObjects.AnalogInput( SET_VIDEO_ROUTING_A__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_VIDEO_ROUTING_A__AnalogSerialInput__, SET_VIDEO_ROUTING_A );
    
    SET_VIDEO_ROUTING_B = new Crestron.Logos.SplusObjects.AnalogInput( SET_VIDEO_ROUTING_B__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_VIDEO_ROUTING_B__AnalogSerialInput__, SET_VIDEO_ROUTING_B );
    
    SET_VIDEO_ROUTING_C = new Crestron.Logos.SplusObjects.AnalogInput( SET_VIDEO_ROUTING_C__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_VIDEO_ROUTING_C__AnalogSerialInput__, SET_VIDEO_ROUTING_C );
    
    SET_VIDEO_ROUTING_D = new Crestron.Logos.SplusObjects.AnalogInput( SET_VIDEO_ROUTING_D__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_VIDEO_ROUTING_D__AnalogSerialInput__, SET_VIDEO_ROUTING_D );
    
    SET_OUTPUT_RESOLUTION = new Crestron.Logos.SplusObjects.AnalogInput( SET_OUTPUT_RESOLUTION__AnalogSerialInput__, this );
    m_AnalogInputList.Add( SET_OUTPUT_RESOLUTION__AnalogSerialInput__, SET_OUTPUT_RESOLUTION );
    
    RECALL_PRESET = new Crestron.Logos.SplusObjects.AnalogInput( RECALL_PRESET__AnalogSerialInput__, this );
    m_AnalogInputList.Add( RECALL_PRESET__AnalogSerialInput__, RECALL_PRESET );
    
    TX__DOLLAR__ = new Crestron.Logos.SplusObjects.StringOutput( TX__DOLLAR____AnalogSerialOutput__, this );
    m_StringOutputList.Add( TX__DOLLAR____AnalogSerialOutput__, TX__DOLLAR__ );
    
    
    REBOOT.OnDigitalPush.Add( new InputChangeHandlerWrapper( REBOOT_OnPush_0, false ) );
    FACTORY_RESET.OnDigitalPush.Add( new InputChangeHandlerWrapper( FACTORY_RESET_OnPush_1, false ) );
    FULL_SCREEN_A.OnDigitalPush.Add( new InputChangeHandlerWrapper( FULL_SCREEN_A_OnPush_2, false ) );
    FULL_SCREEN_B.OnDigitalPush.Add( new InputChangeHandlerWrapper( FULL_SCREEN_B_OnPush_3, false ) );
    FULL_SCREEN_C.OnDigitalPush.Add( new InputChangeHandlerWrapper( FULL_SCREEN_C_OnPush_4, false ) );
    FULL_SCREEN_D.OnDigitalPush.Add( new InputChangeHandlerWrapper( FULL_SCREEN_D_OnPush_5, false ) );
    QUAD_DEFAULT_SCREEN.OnDigitalPush.Add( new InputChangeHandlerWrapper( QUAD_DEFAULT_SCREEN_OnPush_6, false ) );
    SET_VIDEO_ROUTING_A.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_VIDEO_ROUTING_A_OnChange_7, false ) );
    SET_VIDEO_ROUTING_B.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_VIDEO_ROUTING_B_OnChange_8, false ) );
    SET_VIDEO_ROUTING_C.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_VIDEO_ROUTING_C_OnChange_9, false ) );
    SET_VIDEO_ROUTING_D.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_VIDEO_ROUTING_D_OnChange_10, false ) );
    SET_OUTPUT_RESOLUTION.OnAnalogChange.Add( new InputChangeHandlerWrapper( SET_OUTPUT_RESOLUTION_OnChange_11, false ) );
    RECALL_PRESET.OnAnalogChange.Add( new InputChangeHandlerWrapper( RECALL_PRESET_OnChange_12, false ) );
    
    _SplusNVRAM.PopulateCustomAttributeList( true );
    
    NVRAM = _SplusNVRAM;
    
}

public override void LogosSimplSharpInitialize()
{
    
    
}

public UserModuleClass_BG_UHD_QVP_4X2 ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}




const uint REBOOT__DigitalInput__ = 0;
const uint FACTORY_RESET__DigitalInput__ = 1;
const uint FULL_SCREEN_A__DigitalInput__ = 2;
const uint FULL_SCREEN_B__DigitalInput__ = 3;
const uint FULL_SCREEN_C__DigitalInput__ = 4;
const uint FULL_SCREEN_D__DigitalInput__ = 5;
const uint QUAD_DEFAULT_SCREEN__DigitalInput__ = 6;
const uint SET_VIDEO_ROUTING_A__AnalogSerialInput__ = 0;
const uint SET_VIDEO_ROUTING_B__AnalogSerialInput__ = 1;
const uint SET_VIDEO_ROUTING_C__AnalogSerialInput__ = 2;
const uint SET_VIDEO_ROUTING_D__AnalogSerialInput__ = 3;
const uint SET_OUTPUT_RESOLUTION__AnalogSerialInput__ = 4;
const uint RECALL_PRESET__AnalogSerialInput__ = 5;
const uint TX__DOLLAR____AnalogSerialOutput__ = 0;

[SplusStructAttribute(-1, true, false)]
public class SplusNVRAM : SplusStructureBase
{

    public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
    
    
}

SplusNVRAM _SplusNVRAM = null;

public class __CEvent__ : CEvent
{
    public __CEvent__() {}
    public void Close() { base.Close(); }
    public int Reset() { return base.Reset() ? 1 : 0; }
    public int Set() { return base.Set() ? 1 : 0; }
    public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
}
public class __CMutex__ : CMutex
{
    public __CMutex__() {}
    public void Close() { base.Close(); }
    public void ReleaseMutex() { base.ReleaseMutex(); }
    public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
}
 public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
}


}
